#ifndef _INTEGRATION_H_
#define _INTEGRATION_H_

void genTrapez(int n,double* x,double* w,int m)
// Input: n
// Output: Stuetzstellen und Gewichte der verallg. Trapezregel auf [0,1]
// m=n+1 stuetzstellen und Gewichte
{
  int i;
  double h;
  h=1/double(n);
  x[0]=0;
  w[0]=h/2.;
  for (i=1;i<n;i++)
    {
      x[i]=i*h;
      w[i]=h;
    }
   x[n]=1.;
   w[n]=h/2.;
}

void genSimpson(int n,double* x,double* w,int m)
// Input: n
// Output: Stuetzstellen und Gewichte der verallg. Simpsonregel auf [0,1]
// m=2*n+1 stuetzstellen und Gewichte
{
  int i;
  double h;
  h=1/double(n);
  x[0]=0;
  w[0]=h/6.;
  for (i=1;i<=n;i++)
    {
      x[2*i-1]=(double(i)-1./2.)*h;
      w[2*i-1]=2.*h/3.; 
      x[2*i]=i*h;
      w[2*i]=h/3.;
    }
  w[2*n]=h/6.;
  m=2*n+1;
}

void gen38(int n,double* x,double* w,int m)
// Input: n
// Output: Stuetzstellen und Gewichte der verallg. 3/8-regel auf [0,1]
// m=3n+1 Stuetzstellen und Gewichte
{
  int i;
  double h;
  h=1/double(n);
  x[0]=0;
  w[0]=h/8.;
  for (i=1;i<=n;i++)
    {
      x[3*i-2]=(double(i)-1./3.)*h;
      w[3*i-2]=3.*h/8.;  
      x[3*i-1]=(double(i)-2./3.)*h;
      w[3*i-1]=3.*h/8.; 
      x[3*i]=i*h;
      w[3*i]=h/4.;
    }
  w[3*n]=h/8.;
  m=3*n+1;
}







#endif
